{
  open Parser
}

(*正規表現の略記*)
let space = [' ' '\t' '\r']
let digit = ['0'-'9']
let lower = ['a' - 'z']
let upper = ['A' -'Z']
let alpha = lower | upper

rule token = parse
  | space+   { token lexbuf }
  | "("      { LPAREN }
  | ")"      { RPAREN }
  | "["      { LBRACKET }
  | "]"      { RBRACKET }
  | "fun"    { FUN }
  | "Fun"    { LFUN }
  | "->"     { ARROW }
  | "=>"     { DARROW }
  | "forall" { ANY }
  | ";;"     { EOI }
  | ":"      { COLON }
  | ","      { COMMA }
  | upper(alpha|digit)*
             { LVAR (Lexing.lexeme lexbuf) }
  | alpha(alpha|digit)*
             { VAR (Lexing.lexeme lexbuf) }
  | _        { failwith ("unknown token" ^ Lexing.lexeme lexbuf) }
